<template>
  <Dialog
    v-model:visible="value"
    modal
    header="Создание пользователя"
    :style="{ width: '30rem' }"
    :breakpoints="{ '1199px': '75vw', '575px': '90vw' }"
  >
    <AppForm :form="form" class="form" @submit="updateUserExecute()">
      <Message class="my-5" v-if="errorAlertMessage" severity="error">
        {{ errorAlertMessage }}
      </Message>

      <PrimeFormControlFloat>
        <PrimeFormInputTextFloat
          v-model="email"
          name="email"
          rules="required"
          label="Введите E-mail"
          type="email"
          :disabled="getUserLoading"
          w-full
        />
      </PrimeFormControlFloat>

      <PrimeFormControlFloat>
        <PrimeFormInputTextFloat
          id="password"
          v-model="password"
          name="password"
          label="Введите пароль"
          type="password"
          rules="min:8|max:32"
          :disabled="getUserLoading"
          w-full
        />
      </PrimeFormControlFloat>

      <PrimeFormControlFloat>
        <PrimeFormSelect
          id="role"
          v-model="role"
          :options="roles"
          name="role"
          placeholder="Выберете роль"
          optionLabel="name"
          optionValue="value"
          rules="required"
          :disabled="getUserLoading"
          w-full
        />
      </PrimeFormControlFloat>

      <div class="flex justify-end gap-2 mt-5">
        <PrimeButton
          type="submit"
          label="Обновить"
          :loading="getUserLoading || updateUserLoading"
        />
      </div>
    </AppForm>
  </Dialog>
</template>

<script lang="ts" setup>
import useToast from '~/hooks/primevue/useToastP'
import { useUserStore } from '~/stores/user'

const emit = defineEmits(['update:visible', 'action:toggle'])

const props = defineProps({
  visible: {
    type: Boolean,
    required: true
  },
  userId: {
    type: Number,
    required: true
  }
})

const value = computed({
  get() {
    return props.visible
  },
  set(value) {
    emit('update:visible', value)
  }
})

const { roles, update, get } = useUserStore()

const form = useForm()
const toast = useToast()

const errorAlertMessage: Ref<string | boolean> = ref('')

const email = ref('')
const password = ref()
const role = ref()

const {
  execute: updateUserExecute,
  errorValidate,
  loading: updateUserLoading
} = await useAsyncDataFetch(
  () => update(props.userId, email.value, password.value, role.value),
  {
    immediate: false,
    async beforeFetch() {
      errorAlertMessage.value = false

      const validated = await form.validate()

      return validated.valid
    },
    onResponseError(error) {
      errorAlertMessage.value = error.message

      errorValidate(error, {
        validateRules(rules) {
          form.setErrors({
            email: rules?.email,
            password: rules?.password,
            role: rules?.role
          })
        }
      })
    },
    onResponseSuccess() {
      value.value = false
      toast.success('Пользователь успешно создан')
      emit('action:toggle')
    }
  }
)

const {
  data: user,
  execute: getUserExecute,
  loading: getUserLoading
} = await useAsyncDataFetch(() => get(props.userId), {
  immediate: false,
  onResponseError(error) {
    toast.error(error.message, error.detail)
  }
})

const onOpen = async () => {
  await getUserExecute()

  email.value = user.value?.data?.email ?? ''
  role.value = user.value?.data?.role
}

watch(value, (status) => {
  status ? onOpen() : false
})
</script>
